
//roamer3 0125


/***************************************************************************
  This is a library for the AMG88xx GridEYE 8x8 IR camera

  This sketch tries to read the pixels from the sensor

  Designed specifically to work with the Adafruit AMG88 breakout
  ----> http://www.adafruit.com/products/3538

  These sensors use I2C to communicate. The device's I2C address is 0x69

  Adafruit invests time and resources providing this open source code,
  please support Adafruit andopen-source hardware by purchasing products
  from Adafruit!

  Written by Dean Miller for Adafruit Industries.
  BSD license, all text above must be included in any redistribution
 ***************************************************************************/

#include <Servo.h>
#include <Wire.h>
#include <Adafruit_AMG88xx.h>


Adafruit_AMG88xx amg;


//float pixels[AMG88xx_PIXEL_ARRAY_SIZE];
float pixels[64];


float a=0;
    float b=0;
    float c=0;
    float d=0;
   

    float aa=0;//high point
    float bb=0;
    float cc=0;

    int aaa=0;//counter to read value twice
    int bbb=0;
    int cccc=0;
    int eee=0;

    int left=0;//glabal left variable viewed from outside front
    int center=0;
    int right=0;

    int lv=0;//low voltage, 1 is active low voltage

    
    int pir=0;//no person movement detected

    
    int trigPin = 5;
    int echoPin=7;
    float duration;
    int count=0;
    float r=.7;//value to trigger sensing in thermal lower more sensitive
    int repeat=20;//readings before valid thermal
    int repeat1=20;//value to reset to
   
    int bumper=0;//front bumper switch



    void person () {

      //read all the pixels
    amg.readPixels(pixels);

 //gather values for cells 0,1,2,8,9, etc. and add together

    for (int i=32; i<=63; i=i+8) {//gather values in left columns
      d=(pixels [i]);
      a=(a+d);//total value in left columns
      if (d>aa) {
        aa=d;//highest value in left columns
      }

      
      d=(pixels [(i+1)]);
      a=(a+d);
      if (d>aa) {
        aa=d;
      }

      
      d=(pixels [(i+2)]);
      a=(a+d);
      if (d>aa) {
        aa=d;
      }

      
      }


      

      



    for (int i=35; i<=63; i=i+8) {//gather values in center two columns
      d=(pixels [i]);
      b=(b+d);//total value in center
      if (d>bb) {
        bb=d;//highest value in center
      }

      
      d=(pixels [(i+1)]);
      b=(b+d);
      if (d>bb) {
        bb=d;
      }
      
      }


  
    

    for (int i=37; i<=63; i=i+8) {//gather values in right columns
      d=(pixels [i]);
      c=(c+d);//total value in right
      if (d>cc) {
        cc=d;//highet value in right
      }

      
      d=(pixels [(i+1)]);
      c=(c+d);
      if (d>cc) {
        cc=d;
      }

      
      d=(pixels [(i+2)]);
      c=(c+d);
      if (d>cc) {
        cc=d;
      }
      
      } 

      
//obtain average value for a cell in the a,b,c grouping

    a=(a-aa);//remove highest from left group
    b=(b-bb);
    c=(c-cc);



      a=(a/11);//divide by group without highest
      b=(b/7);
      c=(c/11);

     
      

if (aa>bb && aa>cc) {//if highest value in left
  if (aa-a>r) {//if highest minus average > trigger value
    aaa=aaa+1;
    bbb=0;
    cccc=0;
   
  digitalWrite (2,HIGH);//turn on left led

  left=1;
  }
}

  if (bb>aa && bb>cc) {//if center highest
  if (bb-b>r) {//if highest minus average > trigger value
    bbb=bbb+1;
    aaa=0;
    cccc=0;
    

  digitalWrite (4,HIGH);

  center=1;
  }
  }

  if ( (cc>aa) && (cc>bb)) {//if right is highest value
  if (cc-c>r) {//if highest minus average > trigger value
    cccc=cccc+1;
    aaa=0;
    bbb=0;
   
  digitalWrite (6,HIGH);

  right=1;
  }
  }

  a=0;//reset highest and average values
b=0;
c=0;

aa=0;
bb=0;
cc=0;


      
    }//end of person

void dock () {

      //read all the pixels
    amg.readPixels(pixels);

 //gather values for cells 0,1,2,8,9, etc. and add together

    for (int i=0; i<=23; i=i+8) {//gather values in left columns
      d=(pixels [i]);
      a=(a+d);//total value in left columns
      if (d>aa) {
        aa=d;//highest value in left columns
      }

      
      d=(pixels [(i+1)]);
      a=(a+d);
      if (d>aa) {
        aa=d;
      }

      
      d=(pixels [(i+2)]);
      a=(a+d);
      if (d>aa) {
        aa=d;
      }

      
      }


      

      



    for (int i=3; i<=23; i=i+8) {//gather values in center two columns
      d=(pixels [i]);
      b=(b+d);//total value in center
      if (d>bb) {
        bb=d;//highest value in center
      }

      
      d=(pixels [(i+1)]);
      b=(b+d);
      if (d>bb) {
        bb=d;
      }
      
      }


  
    

    for (int i=5; i<=23; i=i+8) {//gather values in right columns
      d=(pixels [i]);
      c=(c+d);//total value in right
      if (d>cc) {
        cc=d;//highet value in right
      }

      
      d=(pixels [(i+1)]);
      c=(c+d);
      if (d>cc) {
        cc=d;
      }

      
      d=(pixels [(i+2)]);
      c=(c+d);
      if (d>cc) {
        cc=d;
      }
      
      } 

      
//obtain average value for a cell in the a,b,c grouping

    a=(a-aa);//remove highest from left group
    b=(b-bb);
    c=(c-cc);



      a=(a/8);//divide by group without highest
      b=(b/5);
      c=(c/8);

     
      

if (aa>bb && aa>cc) {//if highest value in left
  if (aa-a>r) {//if highest minus average > trigger value
    aaa=aaa+1;
    bbb=0;
    cccc=0;
   
  digitalWrite (2,HIGH);//turn on left led

  left=1;
  }
}

  if (bb>aa && bb>cc) {//if center highest
  if (bb-b>r) {//if highest minus average > trigger value
    bbb=bbb+1;
    aaa=0;
    cccc=0;
    

  digitalWrite (4,HIGH);

  center=1;
  }
  }

  if ( (cc>aa) && (cc>bb)) {//if right is highest value
  if (cc-c>r) {//if highest minus average > trigger value
    cccc=cccc+1;
    aaa=0;
    bbb=0;
   
  digitalWrite (6,HIGH);

  right=1;
  }
  }

  a=0;//reset highest and average values
b=0;
c=0;

aa=0;
bb=0;
cc=0;


      
    }//end of dock


    

void setup() {

  pinMode (trigPin, OUTPUT);
  pinMode (echoPin, INPUT);
  pinMode (26,INPUT);//input for pir detector
  pinMode (25,INPUT);//input for front bumper switch
  
 
  
  

    bool status;
    
   
    status = amg.begin();
   

    pinMode(12, OUTPUT); //Initiates Motor Channel A pin
    pinMode(9, OUTPUT); //Initiates Brake Channel A pin

  //Setup Channel B
    pinMode(13, OUTPUT); //Initiates Motor Channel A pin
    pinMode(8, OUTPUT);  //Initiates Brake Channel A pin
   

  

    
    
    pinMode (2,OUTPUT);//left light
    pinMode (4,OUTPUT);//middle light
    pinMode (6,OUTPUT);//right light

    digitalWrite(2,HIGH);//turn leds on
    digitalWrite(4,HIGH);
    digitalWrite(6,HIGH);

    delay(58000);//wait for pir to stabilize

    digitalWrite(2,LOW);
    digitalWrite(4,LOW);
    digitalWrite(6,LOW);
}


void loop() {

   pir=digitalRead(26);

   digitalWrite(2,LOW);
    digitalWrite(4,LOW);
    digitalWrite(6,LOW);

    while (lv==1) {//stay in here while looking for charger

  digitalWrite(12, HIGH); //Establishes forward direction of Channel A
  digitalWrite(9, LOW);   //Disengage the Brake for Channel A
  analogWrite(3, 255);   //Spins the motor on Channel A at full speed

  //Motor B 
  digitalWrite(13, HIGH);  //Establishes forward direction of Channel B
  digitalWrite(8, LOW);   //Disengage the Brake for Channel B
  analogWrite(11, 255);    //Spins the motor on Channel B at full speed

  delay(100);//wait a bit before looking

    bumper=digitalRead(25);//read bump switch

    if (bumper==1) {

 digitalWrite(12, LOW); //Establishes reverse direction of Channel A
  digitalWrite(9, LOW);   //Disengage the Brake for Channel A
  analogWrite(3, 255);   //Spins the motor on Channel A at full speed
  delay(500);//time to reduce spike on power supply


  //Motor B 
  digitalWrite(13, LOW);  //Establishes reverse direction of Channel B
  digitalWrite(8, LOW);   //Disengage the Brake for Channel B
  analogWrite(11, 255);    //Spins the motor on Channel B at full speed

   delay(2000);//time in reverse

digitalWrite(13, HIGH);  //Establishes forward direction of Channel B
  digitalWrite(8, LOW);   //Disengage the Brake for Channel B
  analogWrite(11, 255);    //Spins the motor on Channel B at full speed

   delay(1000);//rotate time
   
digitalWrite(13, HIGH);  //Establishes forward direction of Channel B
  digitalWrite(8, LOW);   //Disengage the Brake for Channel B
  analogWrite(11, 255);    //Spins the motor on Channel B at full speed

      
    }

    dock ();//read sensor for dock


    if (left==1) {

      digitalWrite(12,HIGH);
      digitalWrite(9,LOW);
      analogWrite(3,255);

      analogWrite(11,0);//stop power to other motor
      
      delay(300);

    }


    if (right==1) {

      digitalWrite(13,HIGH);
      digitalWrite(8,LOW);
      analogWrite(11,255);

      analogWrite(3,0);//stop power to other motor

      delay(300);

    }

    left=0;
    right=0;
    digitalWrite(2,LOW);
    digitalWrite(4,LOW);
    digitalWrite(6,LOW);

    
    }

    
    
   

   while (pir==1) {
    



    digitalWrite (2,LOW);//make sure leds are off
    digitalWrite (4,LOW);
    digitalWrite (6,LOW);

    left=0;//reset thermal readings
    center=0;
    right=0;

   
    


    

    digitalWrite(12, HIGH); //Establishes forward direction of Channel A
  digitalWrite(9, LOW);   //Disengage the Brake for Channel A
  analogWrite(3, 0);   //Spins the motor on Channel A at zero speed

  //Motor B backward @ half speed
  digitalWrite(13, HIGH);  //Establishes forward direction of Channel B
  digitalWrite(8, LOW);   //Disengage the Brake for Channel B
  analogWrite(11, 0);    //Spins the motor on Channel B at zero speed

   

    
    digitalWrite(trigPin, HIGH);
    delay(1);
    digitalWrite(trigPin, LOW);
    duration=pulseIn(echoPin,HIGH,6000);
    bumper=digitalRead(25);

    if((duration<3000 && duration>500)||(bumper==1)) {
    

      delay(1000);//sit 1 second
      
    //backup
    digitalWrite(12, LOW);  //Establishes reverse direction of Channel A
    digitalWrite(9, LOW);   //Disengage the Brake for Channel A
    analogWrite(3, 255);    //Spins the motor on Channel A at half speed
  
    //Motor B reverse @ full speed
    digitalWrite(13, LOW); //Establishes reverse direction of Channel B
    digitalWrite(8, LOW);   //Disengage the Brake for Channel B
    analogWrite(11, 255);   //Spins the motor on Channel B at full speed

    delay(1000);

      
    //turn around
    digitalWrite(12, HIGH);  //Establishes forward direction of Channel A
    digitalWrite(9, LOW);   //Disengage the Brake for Channel A
    analogWrite(3, 255);    //Spins the motor on Channel A at half speed
  
    //Motor B forward @ full speed
    digitalWrite(13, LOW); //Establishes reverse direction of Channel B
    digitalWrite(8, LOW);   //Disengage the Brake for Channel B
    analogWrite(11, 255);   //Spins the motor on Channel B at full speed

    delay(2000);//time to turn around

    
    //stop motors
    digitalWrite(12, HIGH);  //Establishes forward direction of Channel A
  digitalWrite(9, LOW);   //Disengage the Brake for Channel A
  analogWrite(3, 0);    //Spins the motor on Channel A at zero speed
  
  //Motor B forward @ full speed
  digitalWrite(13, HIGH); //Establishes forward direction of Channel B
  digitalWrite(8, LOW);   //Disengage the Brake for Channel B
  analogWrite(11, 0);   //Spins the motor on Channel B at zero speed

  delay (6000);//delay before escaping loop
  digitalWrite(2,LOW);//turn off leds
  digitalWrite(4,LOW);
  digitalWrite(6,LOW);

  repeat=repeat1;//# of times before accepting reading

  
  pir=0;//set pir to escape while loop
      
      
      
    }

  
   
  person ();//read thermal sensor

  if (pir==1) {  

   if (left==1) {
 
  digitalWrite(12, HIGH);  //Establishes forward direction of Channel B
  digitalWrite(9, LOW);   //Disengage the Brake for Channel B
  analogWrite(3, 255);    //Spins the motor on Channel B

  
  
  delay(300);
  }
  
 

 

if (center==1) {
  

  digitalWrite(12, HIGH);  //Establishes forward direction of Channel A
  digitalWrite(9, LOW);   //Disengage the Brake for Channel A
  analogWrite(3, 255);    //Spins the motor on Channel A at half speed
  
  //Motor B forward @ full speed
  digitalWrite(13, HIGH); //Establishes forward direction of Channel B
  digitalWrite(8, LOW);   //Disengage the Brake for Channel B
  analogWrite(11, 255);   //Spins the motor on Channel B at full speed

 

  
  delay(300);
  }

 



  if (right==1) {

  digitalWrite(13, HIGH); //Establishes forward direction of Channel A
  digitalWrite(8, LOW);   //Disengage the Brake for Channel A
  analogWrite(11, 255);   //Spins the motor on Channel A at full speed


  
  delay(300);
  }
  



  

}









  }
}


         


      
    
